
; Lite 3 v1.0 - By Laine Walker-Avina
; TI-83/83+ (ION) - Port by Jason Kovacs
; MirageOS Version - Ported on 07/13/00

#include "ti83plus.inc"
#include "mirage.inc"

player            = saferam1+0   ;Current Player (Byte)
board             = saferam1+1   ;Board (9 bytes)
counter           = saferam1+10  ;Counter to track how many turns go by (Byte)
plsta             = saferam1+11  ;Player "Stack" (18 Bytes)
ldirplsta         = saferam1+29  ;player "Stack" used to shift 3 bytes -->

	.org $9d93
	.db $BB,$6D

	ret
	.db 1
Button:
	.db %00000000,%00000000
	.db %00111011,%10111000
	.db %01111100,%01101100
	.db %01111100,%01010100
	.db %01111100,%01101100
	.db %00111011,%10111000
	.db %01101111,%11000100
	.db %01010111,%11000100
	.db %01101111,%11000100
	.db %00111011,%10111000
	.db %01101100,%01111100
	.db %01010100,%01111100
	.db %01101100,%01111100
	.db %00111011,%10111000
	.db %00000000,%00000000
Description:
	.db "Lite 3 v1.0  -  A  TCPA  Game",0

Start_Of_Program:
   SET textEraseBelow, (IY+textflags)
   SET textwrite, (IY+sgrflags)

   xor a
   ld hl, saferam1
   ld de, saferam1+1
   ld (hl), a
   ld bc, 128
   LDIR
   inc a
   ld (player), a

   bcall(_grbufclr)
   ld hl, TitleS
   ld de, plotsscreen
   call DispRLE
   ld de, 46*256+3
   ld hl, author
   call setvputs
   ld de, 54*256+3
   call setvputs
   ld de, 37*256+76
   call setvputs
   call FastCopy

   call Waitkey
   cp $0F
   jp z, Exit
   cp $37
   jp z, Exit
Main:
   bcall(_grbufclr)
   ld bc, 21*256+5
   ld de, board	
   ld a, 9 
redrawloop:
   push af
   push de
   push bc
   ld a, (de)
   or a
   call z, drawblankspace	
   cp 1
   call z, drawgreenspace
   cp 2
   call z, drawredspace
   call PutSprite16
   pop bc
   ld a, 19
   add a, b
   ld b, a
   cp 78
   jr nz, continue_redraw
   ld b, 21
   ld a, 19
   add a, c
   ld c, a
continue_redraw: 
   pop de
   pop af
   inc de
   dec a
   jr nz, redrawloop

put_corner_text:
   SET textInverse, (IY+textFlags)
   ld de, 1*256+1
   ld hl, Lite3
   call setvputs
   ld de, 1*256+76
   ld hl, Ply1
   ld a,(player)
   cp 1
   jr z, put_ply_text
   ld hl, Ply2
put_ply_text:
   call setvputs
   RES textInverse, (IY+textFlags)

   call FastCopy
   call checkwin
KeyLoop:
   call Waitkey
   cp $22
   jr z, l1p
   cp $1A
   jr z, l2p
   cp $12
   jr z, l3p
   cp $23
   jr z, l4p
   cp $1B
   jr z, l5p
   cp $13
   jr z, l6p
   cp $24
   jr z, l7p
   cp $1C
   jr z, l8p
   cp $14
   jr z, l9p
   cp $0F
   jr z, Exit
   cp $37
   jr nz, KeyLoop
Exit:
   bcall(_ClrLCDFull)
   RES textwrite, (IY+sgrflags)
   RES textEraseBelow,(IY+textFlags)
   ret

l1p:
   ld de,$06             ; DE holds offset of our square in memory
   jr updateboard        ; now we can draw the piece
l2p:
   ld de,$07             ; Same for all others, with different offset.
   jr updateboard
l3p:
   ld de,$08
   jr updateboard
l4p:
   ld de,$03
   jr updateboard
l5p:
   ld de,$04
   jr updateboard
l6p:
   ld de,$05
   jr updateboard
l7p:
   ld de,$00
   jr updateboard
l8p:
   ld de,$01
   jr updateboard
l9p:
   ld de,$02

updateboard:
   ld hl,board            ; load in the address of the board
   add hl,de              ; add the offset of our square
   xor a                  ; set a to 0 (faster than LD A,0)
   cp (hl)                ; is this square empty (set to 0)?
   jr z,placepiece        ; then we can put one here
   jr jump_to_main        ; go to the top of the game loop

placepiece:
   ld a,(player)          ; load in who's turn it is
   ld (hl),a              ; mark the square as that person's
   call unlite

flipturn:
   ld hl,player           ; load in who's turn it is
   ld a,(hl)              ; copy it to A for checking
   cp $01                 ; is it green turn?
   jr z,rturnnext         ; then it's red's turn next, jump there
   ld (hl),$01            ; must be green's turn next, set it to that
   jr jump_to_main        ; we're done, go on to next move
rturnnext:
   ld (hl),$02            ; same as above, but for green's turn next
jump_to_main:             ; just like above
   jp Main

drawblankspace:
   ld hl, NoLite
   ret
drawgreenspace:
   ld hl, GreenLite
   ret
drawredspace:
   ld hl, RedLite
   ret

unlite:
   ld a, (counter)
   cp 6
   jr z, UL_go_on
   inc a
   ld (counter),a
   call UL_push_plsta
   ret

UL_go_on:                 ; de=offset bc=l"x" 
   push de
   push bc
   call UL_pop_plsta
   ld hl,board
   add hl, de
   ld (hl), 0

   ld hl, plsta
   pop bc
   pop de
   call UL_push_plsta
   ret

UL_push_plsta:            ; hl=stack stack(de=offset bc=sprite loc)
   push de
   push bc
   ld hl, plsta+14
   ld de, plsta+17
   ld bc, 18
   lddr
   pop bc
   pop de
   ld ix, plsta
   ld a, e
   ld (ix),a
   ld a, b
   ld (ix+1),a
   ld a, c
   ld (ix+2),a
   ret

UL_pop_plsta:             ; hl=stack de=offset bc=sprite location
   ld ix, plsta
   ld d, 0
   ld e, (ix+15)
   ld b, (ix+16)	
   ld c, (ix+17)
   ret

checkwin:
cw1:			  ; row 1 horiz
   ld ix,board
   ld a,(ix+0)
   or a
   jr z,cw2
   cp (ix+1)
   jr nz,cw2
   cp (ix+2)
   jr z,winner
cw2:			  ; col 1 vert
   cp (ix+3)
   jr nz,cw3
   cp (ix+6)
   jr z,winner
cw3:			  ; row 2 horiz
   ld a,(ix+4)
   or a
   jr z,cw4
   cp (ix+3)
   jr nz,cw4
   cp (ix+5)
   jr z,winner
cw4:			  ; col 2 vert
   cp (ix+1)
   jr nz,cw5
   cp (ix+7)
   jr z,winner
cw5:			  ; row 3 horiz
   ld a,(ix+8)
   or a
   jr z,cw8
   cp (ix+7)
   jr nz,cw6
   cp (ix+6)
   jr z,winner
cw6:			  ; col 3 vert
   cp (ix+5)
   jr nz,cw7
   cp (ix+2)
   jr z,winner
cw7:			  ; diag \
   cp (ix+4)
   jr nz,cw8
   cp (ix+0)
   jr z,winner
cw8:			  ; diag /
   ld a,(ix+2)
   cp (ix+4)
   ret nz
   cp (ix+6)
   ret nz

winner:
   or a
   ret z
   dec a
   pop de
   jr nz,player2won
   ld hl,p1win
   jr printmessage
player2won:
   ld hl,p2win
printmessage:
   ld de,28*256+20
   SET textInverse, (IY+textFlags)
   call setvputs
   RES textInverse, (IY+textFlags)
   call FastCopy
   call Waitkey
   cp $0F
   jp z, Exit
   cp $37
   jp z, Exit
   jp Start_Of_Program

PutSprite16:
   push hl
   push ix
   push hl
   pop ix
   ld a, b
   ld l, c
   ld bc, 16*256+2
   call LargeSprite
   pop ix
   pop hl
   ret

Waitkey:
   halt
   bcall(_getcsc)
   or a
   jr nz, Waitkey
Waitkey2:
   halt
   bcall(_getcsc)
   or a
   ret nz
   jr Waitkey2

p1win:
   .db " PLAYER  1  WINS !!!",0 
p2win:
   .db " PLAYER  2  WINS !!!",0
author:
   .db "By  Laine  Walker-Avina",0
porter:
   .db "Ported  By Jason  Kovacs",0
vernum:
   .db "v 1.0",0
Lite3:
   .db " Lite 3",0
Ply1:
   .db " Ply: 1",0
Ply2:
   .db " Ply: 2",0

NoLite:
   .db %00000111,%11100000
   .db %00011000,%00011000
   .db %00100000,%00000100
   .db %01000000,%00000010
   .db %01000000,%00000010
   .db %10000000,%00000001
   .db %10000000,%00000001
   .db %10000000,%00000001
   .db %10000000,%00000001
   .db %10000000,%00000001
   .db %10000000,%00000001
   .db %01000000,%00000010
   .db %01000000,%00000010
   .db %00100000,%00000100
   .db %00011000,%00011000
;  .db %00000111,%11100000

RedLite:
   .db %00000111,%11100000
   .db %00011111,%11111000
   .db %00111111,%11111100
   .db %01111111,%11111110
   .db %01111111,%11111110
   .db %11111111,%11111111
   .db %11111111,%11111111
   .db %11111111,%11111111
   .db %11111111,%11111111
   .db %11111111,%11111111
   .db %11111111,%11111111
   .db %01111111,%11111110
   .db %01111111,%11111110
   .db %00111111,%11111100
   .db %00011111,%11111000
;  .db %00000111,%11100000

GreenLite:
   .db %00000111,%11100000
   .db %00011010,%10111000
   .db %00110101,%01010100
   .db %01101010,%10101010
   .db %01010101,%01010110
   .db %10101010,%10101011
   .db %11010101,%01010101
   .db %10101010,%10101011
   .db %11010101,%01010101
   .db %10101010,%10101011
   .db %11010101,%01010101
   .db %01101010,%10101010
   .db %01010101,%01010110
   .db %00101010,%10101100
   .db %00011101,%01011000
   .db %00000111,%11100000

TitleS:
   .db $91,$00,$25,$91,$07,$03,$91,$00,$08,$07,$0F,$88
   .db $88,$83,$81,$FF,$FF,$FC,$0F,$FF,$E0,$08,$9F,$D0
   .db $50,$44,$42,$00,$00,$02,$10,$00,$10,$10,$5F,$F0
   .db $70,$48,$24,$00,$00,$01,$20,$00,$08,$10,$5F,$D0
   .db $50,$48,$24,$00,$00,$01,$20,$00,$08,$10,$4F,$91
   .db $88,$03,$22,$00,$00,$02,$20,$00,$10,$10,$47,$47
   .db $17,$08,$21,$FF,$07,$FC,$20,$FF,$E0,$10,$42,$22
   .db $22,$08,$20,$01,$04,$00,$20,$80,$00,$10,$47,$17
   .db $47,$08,$20,$01,$04,$00,$20,$80,$00,$10,$48,$8F
   .db $88,$88,$20,$01,$04,$00,$20,$80,$00,$10,$50,$5F
   .db $D0,$48,$20,$01,$04,$00,$20,$80,$00,$10,$50,$7F
   .db $F0,$48,$20,$01,$04,$00,$20,$80,$00,$10,$50,$5F
   .db $D0,$48,$20,$01,$04,$00,$20,$80,$00,$10,$48,$8F
   .db $88,$88,$20,$01,$04,$00,$20,$FF,$00,$10,$47,$17
   .db $47,$08,$20,$01,$04,$00,$20,$00,$80,$10,$42,$22
   .db $22,$08,$20,$01,$04,$00,$20,$00,$40,$10,$47,$47
   .db $17,$08,$20,$01,$1F,$F0,$20,$00,$40,$10,$48,$88
   .db $8F,$88,$20,$01,$3F,$FC,$20,$00,$80,$10,$50,$50
   .db $5F,$C8,$20,$01,$7F,$FE,$20,$FF,$00,$10,$50,$70
   .db $7F,$C8,$20,$01,$7C,$3F,$20,$80,$00,$10,$50,$50
   .db $5F,$C8,$20,$01,$34,$0F,$20,$80,$00,$10,$48,$88
   .db $8F,$88,$20,$01,$04,$07,$20,$80,$00,$10,$47,$07
   .db $07,$08,$20,$01,$04,$07,$20,$80,$00,$10,$40,$00
   .db $00,$08,$20,$01,$04,$07,$20,$80,$00,$10,$7F,$FF
   .db $FE,$08,$20,$01,$04,$0F,$20,$80,$00,$10,$00,$00
   .db $01,$08,$20,$01,$04,$FE,$20,$FF,$E0,$10,$91,$00
   .db $03,$88,$20,$01,$05,$FC,$20,$00,$10,$10,$91,$00
   .db $03,$88,$20,$01,$05,$FE,$20,$00,$08,$10,$91,$00
   .db $03,$88,$20,$01,$04,$FF,$20,$00,$08,$08,$00,$00
   .db $01,$04,$40,$00,$88,$0F,$10,$00,$10,$07,$FF,$FF
   .db $FE,$03,$80,$00,$70,$07,$0F,$FF,$E0,$91,$00,$08
   .db $07,$91,$00,$0B,$07,$91,$00,$0B,$07,$91,$00,$0B
   .db $07,$91,$00,$03,$0C,$3E,$77,$18,$1C,$C8,$BC,$30
   .db $0F,$91,$00,$03,$12,$08,$84,$A4,$21,$2D,$A0,$78
   .db $3E,$91,$00,$03,$1E,$08,$87,$3C,$2D,$EA,$B8,$7F
   .db $FC,$91,$00,$03,$12,$08,$84,$24,$25,$28,$A0,$3F
   .db $F8,$91,$00,$03,$12,$08,$74,$24,$19,$28,$BC,$1F
   .db $E0,$91,$00,$FF

.end
